Name:           openstack-cyborg
Version:        6.0.0
Release:        2
Summary:        OpenStack Accelerator as a Service
License:        Apache-2.0
Group:          Applications/System
URL:            https://launchpad.net/cyborg
Source0:        https://tarballs.opendev.org/openstack/cyborg/openstack-cyborg-6.0.0.tar.gz
Source1:        openstack-cyborg-api.service
Source2:        openstack-cyborg-conductor.service
Source3:        openstack-cyborg-agent.service

BuildRequires:  fdupes
BuildRequires:  openstack-macros
BuildRequires:  openstack-tempest
BuildRequires:  python3-wsme == 0.10.1
BuildRequires:  python3-ddt
BuildRequires:  python3-eventlet
BuildRequires:  python3-fixtures
BuildRequires:  python3-jsonpatch
BuildRequires:  python3-keystoneauth1
BuildRequires:  python3-keystonemiddleware
BuildRequires:  python3-mock
BuildRequires:  python3-oslo-config
BuildRequires:  python3-oslo-context
BuildRequires:  python3-oslo-db == 8.5.1
BuildRequires:  python3-oslo-i18n
BuildRequires:  python3-oslo-log
BuildRequires:  python3-oslo-policy
BuildRequires:  python3-oslo-versionedobjects
BuildRequires:  python3-oslo-sphinx
BuildRequires:  python3-oslotest
BuildRequires:  python3-pecan
BuildRequires:  python3-psutil
BuildRequires:  python3-six
Requires:       openstack-cyborg-api = %{version}-%{release}
Requires:       openstack-cyborg-conductor = %{version}-%{release}
Requires:       openstack-cyborg-agent = %{version}-%{release}
BuildArch:      noarch

BuildRequires:  systemd
Requires(post): systemd
Requires(postun): systemd
Requires(pre):  shadow-utils
Requires(preun): systemd


%description
Cyborg (previously known as Nomad) is an OpenStack project that aims to
provide a general purpose management framework for acceleration
resources (i.e. various types of accelerators such as GPU, FPGA, ASIC,
NP, SoCs, NVMe/NOF SSDs, ODP, DPDK/SPDK and so on).

%package        api
Summary:        Cyborg API service
Requires:       openstack-cyborg-common = %{version}-%{release}

%description    api
Cyborg API service

%package        conductor
Summary:        Cyborg conductor service
Requires:       openstack-cyborg-common = %{version}-%{release}

%description    conductor
Cyborg conductor service

%package        agent
Summary:        Cyborg agent service
Requires:       openstack-cyborg-common = %{version}-%{release}

%description    agent
Cyborg agent service

%package        common
Summary:        Cyborg common files
Requires:       python3-cyborg = %{version}-%{release}

%description    common
Cyborg common files

%package -n     python3-cyborg
Summary:        Cyborg Python library
Requires:       python3-sqlalchemy
Requires:       python3-wsme == 0.10.1
Requires:       python3-alembic
Requires:       python3-eventlet
Requires:       python3-jsonpatch
Requires:       python3-keystoneauth1
Requires:       python3-keystonemiddleware
Requires:       python3-oslo-concurrency
Requires:       python3-oslo-config
Requires:       python3-oslo-context
Requires:       python3-oslo-db == 8.5.1
Requires:       python3-oslo-i18n
Requires:       python3-oslo-log
Requires:       python3-oslo-messaging
Requires:       python3-oslo-policy
Requires:       python3-oslo-service
Requires:       python3-oslo-utils == 4.8.0
Requires:       python3-oslo-versionedobjects
Requires:       python3-pbr
Requires:       python3-pecan
Requires:       python3-psutil
Requires:       python3-six
Requires:       python3-stevedore

%description -n python3-cyborg
Cyborg (previously known as Nomad) is an OpenStack project that aims to
provide a general purpose management framework for acceleration
resources (i.e. various types of accelerators such as GPU, FPGA, ASIC,
NP, SoCs, NVMe/NOF SSDs, ODP, DPDK/SPDK and so on).

This package contains the Cyborg python libraries.

%prep
%autosetup -p1 -n openstack-cyborg-6.0.0
%py_req_cleanup

%build
%{py3_build}

# config file generation
PYTHONPATH=. oslo-config-generator --config-file tools/config/cyborg-config-generator.conf \
    --output-file etc/cyborg/cyborg.conf.sample
PYTHONPATH=. oslopolicy-sample-generator --config-file tools/config/cyborg-policy-generator.conf \
    --output-file etc/cyborg/policy.json.sample

%install
%{py3_install}
install -d -m 755 %{buildroot}%{_localstatedir}/log/cyborg
install -d -m 755 %{buildroot}%{_sysconfdir}/cyborg

mv %{buildroot}%{_prefix}%{_sysconfdir}/cyborg/*  %{buildroot}%{_sysconfdir}/cyborg/
install -p -D -m 640 etc/cyborg/cyborg.conf.sample %{buildroot}%{_sysconfdir}/cyborg/cyborg.conf
install -p -D -m 640 etc/cyborg/policy.yaml %{buildroot}%{_sysconfdir}/cyborg/policy.yaml

install -p -D -m 644 %{SOURCE1} %{buildroot}%{_unitdir}/openstack-cyborg-api.service
install -p -D -m 644 %{SOURCE2} %{buildroot}%{_unitdir}/openstack-cyborg-conductor.service
install -p -D -m 644 %{SOURCE3} %{buildroot}%{_unitdir}/openstack-cyborg-agent.service

# remove duplicates
%fdupes %{buildroot}%{python3_sitelib}

%pre common
%openstack_pre_user_group_create cyborg cyborg /sbin/nologin

%post api
%systemd_post openstack-cyborg-api.service
%post conductor
%systemd_post openstack-cyborg-conductor.service
%post agent
%systemd_post openstack-cyborg-agent.service

%preun api
%systemd_preun openstack-cyborg-api.service
%preun conductor
%systemd_preun openstack-cyborg-conductor.service
%preun agent
%systemd_preun openstack-cyborg-agent.service

%postun api
%systemd_postun_with_restart openstack-cyborg-api.service
%postun conductor
%systemd_postun_with_restart openstack-cyborg-conductor.service
%postun agent
%systemd_postun_with_restart openstack-cyborg-agent.service

%files
%license LICENSE
%doc README.rst

%files api
%{_bindir}/cyborg-api
%{_bindir}/cyborg-dbsync
%{_bindir}/cyborg-status
%{_bindir}/cyborg-wsgi-api
%config(noreplace) %attr(0640, root, cyborg) %{_sysconfdir}/cyborg/api-paste.ini
%config(noreplace) %attr(0640, root, cyborg) %{_sysconfdir}/cyborg/policy.yaml
%{_unitdir}/openstack-cyborg-api.service

%files conductor
%{_bindir}/cyborg-conductor
%{_unitdir}/openstack-cyborg-conductor.service

%files agent
%{_bindir}/cyborg-agent
%{_unitdir}/openstack-cyborg-agent.service

%files common
%dir %attr(0750, root, cyborg) %{_sysconfdir}/cyborg/
%config(noreplace) %attr(0640, root, cyborg) %{_sysconfdir}/cyborg/cyborg.conf
%dir %attr(0750, cyborg, cyborg) %{_localstatedir}/log/cyborg

%files -n python3-cyborg
%doc README.rst
%license LICENSE
%{python3_sitelib}/cyborg/
%{python3_sitelib}/openstack_cyborg*.egg-info

%changelog
* Wed Mar 01 2023 OpenStack_SIG <openstack@openeuler.org> - 6.0.0-2
- Fix install error

* Mon Feb 21 2022 wangxiyuan <wangxiyuan1007@gmail.com> - 6.0.0-1
- Support OpenStack Wallaby release
